/*
 * La solucin de este laboratorio fue
 * bajada desde la pgina del curso IIC1102.
 * 
 * Laboratorio 7 - IIC1102 - Primer Semestre 2005
 * 
 * */

// Clase: Urgencia1

import iic1102Package.*;

public class Urgencia1 {
		// Lista de espera de pacientes
		private Paciente lista[];
		// Indice del primer lugar disponible en la lista
		private int nPacientes;
		
	/**
	 * Constructor
	 */
	public Urgencia1(int maxLista) {
		// Se crea una lista de tamao maxLista
		lista = new Paciente[maxLista];
		// Inicialmente apunta a la posicin 0
		nPacientes=0;
	}
	
	/**
	 * llegadaPaciente: Inserta a un paciente que se recibe
	 * como parmetro en la lista de espera de acuerdo a su
	 * prioridad
	 * @param p
	 */
	public void llegadaPaciente(Paciente p){
		
		// Posicin donde se insertar el paciente 
		int posicion;
		// Chequeo que haya espacio disponible
		if (lista.length > nPacientes){
			// Antes de agregar al paciente debo determinar donde ubicarla
			// de acuerdo a su prioridad
			posicion = encontrarPosicion(p.obtenerPrioridad());
			// Libero un espacio en la posicin donde quiero insertar al
			// nuevo paciente
			liberarEspacio(posicion);
			// Inserto el paciente en la lista
			lista[posicion]= p;
			// El primer lugar disponible pasa a la siguiente posicin
			nPacientes++;
		}else
			// No se puede ingresar
			Interfaz.MostrarMensajeConsola("La lista de espera est llena, no es posible ingresar el paciente a la lista");
		
		
	}

	/**
	 * Encuentra la posicin donde debe insertar el 
	 * elemento en la lista de espera de acuerdo a su 
	 * prioridad
	 * @param prioridad
	 * @return
	 */
	public int encontrarPosicion(int prioridad)
	{
		// Indice para recorrer la lista de espera
		int i=0;
	
		// Mientras la prioridad sea mayor paso al siguiente elemento de la lista
		// Es importante chequear primero que el rango sea vlido
		// sino podriamos estar accediendo a un elemento "null"
		while(i < nPacientes && lista[i].obtenerPrioridad() >= prioridad)
			i++;
			
		// Retorna el indice de la primer paciente de la lista
		// cuya prioridad es menor que la del que quiero ingresar
		return i;
	}
	
	/**
	 * Libera un espacio en la posicion que se recibe como parmetro
	 * @param posicion
	 */
	public void liberarEspacio(int posicion){
		
		// A partir del ltimo elemento desplazo hacia la derecha
		// uno a uno los elementos de la lista
		for(int i=nPacientes;i>posicion;i--)
		{
			lista[i]=lista[i-1];
		}	
	}
	
	/**
	 * imprimirLista: Imprime la lista de espera
	 */
	public void imprimirLista()
	{
		// Si no hay pacientes
		if(nPacientes==0)
			Interfaz.MostrarMensajeConsola("La lista est vaca\n");
			
		// Imprime uno a uno los pacientes de la lista
		for(int i=0;i<nPacientes;i++){
			Interfaz.MostrarMensajeConsola("Elemento "+i);
			lista[i].imprimirPaciente();
			Interfaz.MostrarMensajeConsola("");
		}
	}
	
	/**
	 * AtenderPaciente: Atiende al paciente con mayor prioridad de la lista de espera
	 * Actualiza la lista y retorna el paciente atendido
	 */
	public Paciente atenderPaciente()
	{
		// Variable para almacenar el paciente que ser atendido
		Paciente atendido;
		
		// Si hay pacientes
		if(nPacientes>0){
			
			// Saco al paciente con mayor prioridad de la lista de espera
			// Por la forma en que es construda la lista siempre es el primero de la lista
			atendido=lista[0];
			
			// Muevo hacia la izquierda a todos los pacientes de la lista de espera	
			moverIzquierda(0);
			
			// Indico que hay un paciente menos en la lista
			nPacientes--;
		}
		else
			// Si no hay pacientes en la lista retorno null
			atendido=null;
		
		// Retorno el paciente atendido
		return atendido;
		
	}

	/**
	 * moverIzquierda: Mueve hacia la izquierda los pacientes de la lista que estn
	 * a la derecha de la posicin de inicio que se le da como parmetro  
	 */
	public void moverIzquierda(int inicio)
	{
		for(int i=inicio;i<(nPacientes-1);i++)
			lista[i]=lista[i+1];
	}

}
	
	
	

