/*
 * La solucin de este laboratorio fue
 * bajada desde la pgina del curso IIC1102.
 * 
 * Laboratorio 7 - IIC1102 - Primer Semestre 2005
 * 
 * */

// Clase: Urgencia2

import iic1102Package.Interfaz;

public class Urgencia2 {
	// Lista de espera de pacientes
	private Paciente lista[];
	// Indice del primer lugar disponible en la lista
	private int nPacientes;
	
	/**
	 * Constructor
	 */
	public Urgencia2(int maxLista) {
		// Se crea una lista de tamao maxLista
		lista = new Paciente[maxLista];
		// Inicialmente apunta a la posicin 0
		nPacientes=0;
	}
	
	/**
	 * llegadaPaciente: Inserta a un paciente que se recibe
	 * como parmetro en la lista de espera de acuerdo a su
	 * prioridad
	 * @param p
	 */
	public void llegadaPaciente(Paciente p){
	
		// Chequeo que haya espacio disponible
		if (lista.length > nPacientes){
			// Lo inserto en el primer lugar disponible en la lista de espera
			lista[nPacientes]=p;
			// El primer lugar disponible pasa a la siguiente posicin
			nPacientes++;
		}else
			// No se puede ingresar
			Interfaz.MostrarMensajeConsola("La lista de espera est llena, no es posible ingresar el paciente a la lista");
		
	}
	
	/**
	 * imprimirLista: Imprime la lista de espera
	 */
	public void imprimirLista()
	{
		// Si no hay pacientes
		if(nPacientes==0)
			Interfaz.MostrarMensajeConsola("La lista est vaca\n");
		
		// Imprime uno a uno los pacientes de la lista
		for(int i=0;i<nPacientes;i++){
			Interfaz.MostrarMensajeConsola("Elemento "+i);
			lista[i].imprimirPaciente();
			Interfaz.MostrarMensajeConsola("");
		}
	}

	/**
	 * AtenderPaciente: Atiende al paciente con mayor prioridad de la lista de espera
	 * Actualiza la lista y retorna el paciente atendido
	 */
	public Paciente atenderPaciente()
	{
		Paciente atendido;
		int indice;
		
		// Si hay pacientes
		if(nPacientes>0){
			
			// Busco el ndice del paciente que tiene mayor prioridad en la lista de espera
			indice=mayorPrioridad();
			
			// Saco al paciente con mayor prioridad de la lista de espera
			atendido=lista[indice];
			
			// Muevo hacia la izquierda a los pacientes de la lista de espera
			// que estn a la derecha del que tiene mayor prioridad
			moverIzquierda(indice);
			
			// Indico que hay un paciente menos en la lista
			nPacientes--;
		}
		else
			atendido=null;
		
		// Retorno el paciente atendido
		return atendido;
		
	}

	/**
	 * moverIzquierda: Mueve hacia la izquierda los pacientes de la lista 
	 * a partir de una posicin de inicio que se le da como parmetro  
	 */
	public void moverIzquierda(int inicio)
	{
		for(int i=inicio;i<(nPacientes-1);i++)
			lista[i]=lista[i+1];
	}
	
	/**
	 * mayorPrioridad: Busco el indice del paciente que tiene mayor prioridad 
	 * en la lista de espera y lo retorno
	 */
	public int mayorPrioridad()
	{
		
		// Indice del paciente con mayor prioridad en la lista
		int indice = 0;
		// Prioridad del paciente con mayor prioridad en la lista
		int prioridadMayor = 0;
		
		if(nPacientes>0)
		{	
			// Suponemos inicialmente que el paciente con mayor prioridad es el primero
			// de la lista de espera
			indice=0;
			prioridadMayor=lista[0].obtenerPrioridad();
			
			
			for(int i=0;i<nPacientes;i++)
			{
				// Comparo la prioridad del que tiene mayor prioridad hasta el momento
				// con la prioridad del paciente almacenado en la posicin i
				// Si es mayor ese paciente se convierte en el paciente con mayor prioridad
				if(lista[i].obtenerPrioridad()>prioridadMayor){
					indice=i;
					prioridadMayor=lista[i].obtenerPrioridad();
				}
			}
		}
		// Retornamos el indice
		return indice;
	}

	
}
