/**
 * IIC1102 - Introduccion a la Programacion
 *
 * IO Archivos - EscritorArchivo
 * 			- Permite escribir texto en un archivo
 */
package iic1102Package;

import java.io.*;
import javax.swing.JOptionPane;

public class EscritorArchivo 
{
	private File 			 archivo;
	private FileOutputStream fs;
	private PrintStream 	 escritor;
	
	
	/**
	 * Constructor de la clase
	 * @param nomArchivo Nombre del archivo que se desea escribir
	 */
	public EscritorArchivo (String nomArchivo)
	{
		try
		{
			archivo = new File(nomArchivo);
				/**
				 * Tengase en cuenta que si el archivo no existia en disco, este metodo
				 * no lo creara, para ello debemos apoyarnos en un FileOutputStream
				 */
			fs       = new FileOutputStream(archivo);
			escritor = new PrintStream(fs); 
		}
		catch (Exception e)
		{
			if (nomArchivo == "")
				JOptionPane.showMessageDialog(null,"Debe ingresar un nombre de archivo vlido");
		}
	}
	
	/**
	 * Permite escribir una linea de texto en el archivo 
	 * @param texto
	 * @return Condicion de termino
	 */
	public boolean EscribirLinea (String texto)
	{
		try
		{
			escritor.println(texto);
		}
		catch (Exception e)
		{
			JOptionPane.showMessageDialog(null,"Se ha producido un error durante la escritura del archivo");
			return(false);
		}
		return (true);
	}

	/**
	 * Permite escribir un double en una linea de texto en el archivo 
	 * @param texto
	 * @return Condicion de termino
	 */
	public boolean EscribirLinea (double valor)
	{
		try
		{
			escritor.println(valor);
		}
		catch (Exception e)
		{
			JOptionPane.showMessageDialog(null,"Se ha producido un error durante la escritura del archivo");
			return(false);
		}
		return (true);
	}
	
	/**
	 * Permite escribir un double en una linea de texto en el archivo 
	 * @param texto
	 * @return Condicion de termino
	 */
	public boolean EscribirLinea (int valor)
	{
		try
		{
			escritor.println(valor);
		}
		catch (Exception e)
		{
			JOptionPane.showMessageDialog(null,"Se ha producido un error durante la escritura del archivo");
			return(false);
		}
		return (true);
	}
	
	/**
	 * Permite cerrar un archivo luego de haber terminado de usarlo
	 * @return true si consiguio cerrar exitosamente el archivo.
	 */
	public boolean CerrarArchivo()
	{
		try
		{
			escritor.close();
		}
		catch (Exception e)
		{
			JOptionPane.showMessageDialog(null,"Se ha producido un error al cerrar el archivo");
			return(false);
		}
		return(true);
	}
}
