package iic1102Package;

import javax.swing.JOptionPane;

public class Interfaz
{

/* *****************************************************************
 * Interfaz con el usuario en modo Grafico
 */
	
	/**
	 * Obtiene un entero desde el usuario mediante una interfaz grafica
	 * @param mensaje Mensaje a desplegar en el cuerpo de la ventana
	 * @return entero obtenido desde el usuario
	 */
    public static int PedirEntero(String mensaje)
    {
        int entero;

        try
        {
           entero = (Integer.parseInt(JOptionPane.showInputDialog(null, mensaje,
                  "Ingrese un numero")));
        }
        catch (Exception exception)
        {
            entero=-1;
            JOptionPane.showMessageDialog(null,"Error - Input","Error grave al ingresar informacion",JOptionPane.ERROR_MESSAGE);
        }

        return(entero);

    }


	/**
	 * Obtiene un entero desde el usuario mediante una interfaz grafica
	 * @param mensaje Mensaje a desplegar en el cuerpo de la ventana
	 * @param inputBoxMessage Mensaje a desplegar en el espacio donde se ingresa el dato
	 * @return entero obtenido desde el usuario
	 */
    public static int PedirEntero(String mensaje, String inputBoxMessage)
    {
        int entero;

        try
        {
           entero = (Integer.parseInt(JOptionPane.showInputDialog(null, mensaje,
                  inputBoxMessage)));
        }
        catch (Exception exception)
        {
            entero=-1;
            JOptionPane.showMessageDialog(null,"Error - Input","Error grave al ingresar informacion",JOptionPane.ERROR_MESSAGE);
        }

        return(entero);

    }

    
	/**
	 * Obtiene un double desde el usuario mediante una interfaz grafica
	 * @param mensaje Mensaje a desplegar en el cuerpo de la ventana
	 * @return double obtenido desde el usuario
	 */
    public static double PedirDouble(String mensaje)
    {
        double entero;

     try
     {
        entero = (Double.parseDouble(JOptionPane.showInputDialog(null, mensaje,
               "Ingrese un numero")));
     }
     catch (Exception exception)
     {
         entero=-1;
         JOptionPane.showMessageDialog(null,"Error - Input","Error grave al ingresar informacion",JOptionPane.ERROR_MESSAGE);
     }

     return(entero);
    }


	/**
	 * Obtiene un double desde el usuario mediante una interfaz grafica
	 * @param mensaje Mensaje a desplegar en el cuerpo de la ventana
	 * @param inputBoxMessage Mensaje a desplegar en el espacio donde se ingresa el dato
	 * @return double obtenido desde el usuario
	 */
    public static double PedirDouble(String mensaje, String inputBoxMessage)
    {
        double entero;

     try
     {
        entero = (Double.parseDouble(JOptionPane.showInputDialog(null, mensaje,
               inputBoxMessage)));
     }
     catch (Exception exception)
     {
         entero=-1;
         JOptionPane.showMessageDialog(null,"Error - Input","Error grave al ingresar informacion",JOptionPane.ERROR_MESSAGE);
     }

     return(entero);
    }
    
    
	/**
	 * Obtiene un String desde el usuario mediante una interfaz grafica
	 * @param mensaje Mensaje a desplegar en el cuerpo de la ventana
	 * @return String obtenido desde el usuario
	 */
    public static String PedirString(String mensaje)
    {
        String texto="";

     try
     {
        texto = JOptionPane.showInputDialog(null, mensaje,
               "");
     }
     catch (Exception exception)
     {
         JOptionPane.showMessageDialog(null,"Error - Input","Error grave al ingresar informacion",JOptionPane.ERROR_MESSAGE);
     }

     return(texto);
    }

    
    /**
	 * Obtiene un String desde el usuario mediante una interfaz grafica
	 * @param mensaje Mensaje a desplegar en el cuerpo de la ventana
	 * @param inputBoxMessage Mensaje a desplegar en el espacio donde se ingresa el dato
	 * @return String obtenido desde el usuario
	 */
    public static String PedirString(String mensaje,String inputBoxMessage)
    {
        String texto="";

     try
     {
        texto = JOptionPane.showInputDialog(null, mensaje,
               inputBoxMessage);
     }
     catch (Exception exception)
     {
         JOptionPane.showMessageDialog(null,"Error - Input","Error grave al ingresar informacion",JOptionPane.ERROR_MESSAGE);
     }

     return(texto);
    }

    
    
/* ****************************************************************************
 * Despliegue de mensajes en modo grafico
 */ 
    
    /**
     * Permite desplegar mensajes en la Consola
     * @param mensaje String a desplegar
     */	
    public static void MostrarMensaje(String mensaje)
    {
        JOptionPane.showMessageDialog(null,mensaje);
    }


    /**
     * Permite desplegar mensajes en la Consola
     * @param mensaje double a desplegar
     */	
    public static void MostrarMensaje(double mensaje)
    {
        JOptionPane.showMessageDialog(null,String.valueOf(mensaje));
    }
    
 
    /**
     * Permite desplegar mensajes en la Consola
     * @param mensaje int a desplegar
     */	
    public static void MostrarMensaje(int mensaje)
    {
        JOptionPane.showMessageDialog(null,String.valueOf(mensaje));
    }
    
/* ************************************************************************
 * Despliegue de mensajes en modo Consola
 */
    
    
    /**
     * Despliega el dato en modo Consola
     * @param mensaje String a desplegar
     */
    public static void MostrarMensajeConsola(String mensaje)
    {
    	System.out.println(mensaje);
    }
    

    /**
     * Despliega el dato en modo Consola
     * @param mensaje double a desplegar
     */
    public static void MostrarMensajeConsola(double mensaje)
    {
    	System.out.println(mensaje);
    }
   
    
    /**
     * Despliega el dato en modo Consola
     * @param mensaje int a desplegar
     */
    public static void MostrarMensajeConsola(int mensaje)
    {
    	System.out.println(mensaje);
    }
    
/* ***************************************************************************/    

}

