/**
 * IIC1102 - Introduccion a la Programacion
 *
 * IO Archivos - EscritorArchivo
 * 			- Permite escribir texto en un archivo
 */
package iic1102Package;

import java.io.*;
import javax.swing.JOptionPane;
import javax.swing.JFileChooser;

public class LectorArchivo 
{
	private File 			  archivo;
	private FileInputStream   fs;
 	private InputStreamReader isr;
 	private BufferedReader	  lector;
	
	
	/**
	 * Constructor de la clase
	 * @param nomArchivo Nombre del archivo que se desea escribir
	 */
	public LectorArchivo (String nomArchivo)
	{
		try
		{
			archivo = new File(nomArchivo);
			fs      = new FileInputStream(archivo);
			isr     = new InputStreamReader(fs);
			lector  = new BufferedReader(isr); 
		}
		catch (Exception e)
		{
			if (nomArchivo == "")
				JOptionPane.showMessageDialog(null,"Debe ingresar un nombre de archivo vlido");
		}
	}
	
	
	public LectorArchivo()
	{
		try
		{
			//mostrar cuadro de dilogo, para que el usuario pueda seleccionar el archivo
		    JFileChooser selectorArchivo = new JFileChooser();
		    
		    selectorArchivo.setFileSelectionMode( JFileChooser.FILES_ONLY );
	
		    int resultado = selectorArchivo.showOpenDialog( null );
	
		    // si el usuario hizo clic en el botn Cancelar del cuadro de dilogo, regresar
		    if ( resultado == JFileChooser.CANCEL_OPTION )
		       return;
	
		    archivo = selectorArchivo.getSelectedFile(); // obtener archivo seleccionado
			fs      = new FileInputStream(archivo);
			isr     = new InputStreamReader(fs);
			lector  = new BufferedReader(isr); 
		}
		catch (Exception e)
		{
			
		}
	}
	
	
	/**
	 * Permite leer una linea de texto desde el archivo 
	 * @return Condicion de termino
	 */
	public String LeerLinea()
	{
		String texto; 
		
		try
		{
			texto = lector.readLine();
		}
		catch (Exception e)
		{
			JOptionPane.showMessageDialog(null,"Se ha producido un error durante la lectura del archivo");
			return(null);
		}
		return (texto);
	}


	
}
