/*
 * Created on Jan 11, 2005
 */
package iic1102Package;

import java.text.*;

/**
 * Funciones de utilidad miscelnea
 * 
 * La utilizacin de esta clase es a travs de mtodos estticos,
 * luego nunca es necesario instanciarla. Es por esto que la clase
 * es abstracta, para detectar el error de tratar de instanciarla.
 * 
 * @author jpcanepa
 */
public abstract class Tools
{
	/**
	 * Genera un numero aleatoreo en el rango [<code>A</code>,<code>B</code>], 
	 * uniformemente distribu&iacute;do
	 * @param A El l&iacute;mite inferior
	 * @param B El l&iacute;mite superior
	 * @return Un n&uacute;mero aleatorio uniformemente distribu&iacute;do
	 * entre <code>A</code> y <code>B</code>
	 */
	public static double randomAB(double A, double B)
	{
		return Math.random()*(B-A)+A;
	}
	
	/**
	 * Formatea un n&uacute;mero redondeando a la cantiadad
	 * de decimales definida en <code>decimales</code>. 
	 * @param valor El n&uacute;mero a redondear
	 * @param decimales El n&uacute;mero de decimales
	 * @return Un string con <code>valor</code> redondeado a 
	 * <code>decimales</code>
	 */
	public static String Redondear(double valor, int decimales)
	{
		String formato = "#.";
		
		while(decimales -- > 0)
		{
			formato += "0";
		}
		
		NumberFormat formatter = new DecimalFormat(formato);
		return formatter.format(valor);
	}
}
